git-rebase.shon commit Merge branch 'ak/bisect-reset-to-switch' (4b3c180)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--onto <newbase>] [<upstream>|--root] [<branch>] [--quiet | -q]'
   7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
   8same name.  When the --onto option is provided the new branch starts
   9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
  10It then attempts to create a new commit for each commit from the original
  11<branch> that does not exist in the <upstream> branch.
  12
  13It is possible that a merge failure will prevent this process from being
  14completely automatic.  You will have to resolve any such merge failure
  15and run git rebase --continue.  Another option is to bypass the commit
  16that caused the merge failure with git rebase --skip.  To restore the
  17original <branch> and remove the .git/rebase-apply working files, use the
  18command git rebase --abort instead.
  19
  20Note that if <branch> is not specified on the command line, the
  21currently checked out branch is used.
  22
  23Example:       git-rebase master~1 topic
  24
  25        A---B---C topic                   A'\''--B'\''--C'\'' topic
  26       /                   -->           /
  27  D---E---F---G master          D---E---F---G master
  28'
  29
  30SUBDIRECTORY_OK=Yes
  31OPTIONS_SPEC=
  32. git-sh-setup
  33set_reflog_action rebase
  34require_work_tree
  35cd_to_toplevel
  36
  37OK_TO_SKIP_PRE_REBASE=
  38RESOLVEMSG="
  39When you have resolved this problem run \"git rebase --continue\".
  40If you would prefer to skip this patch, instead run \"git rebase --skip\".
  41To restore the original branch and stop rebasing run \"git rebase --abort\".
  42"
  43unset newbase
  44strategy=recursive
  45do_merge=
  46dotest="$GIT_DIR"/rebase-merge
  47prec=4
  48verbose=
  49diffstat=$(git config --bool rebase.stat)
  50git_am_opt=
  51rebase_root=
  52force_rebase=
  53
  54continue_merge () {
  55        test -n "$prev_head" || die "prev_head must be defined"
  56        test -d "$dotest" || die "$dotest directory does not exist"
  57
  58        unmerged=$(git ls-files -u)
  59        if test -n "$unmerged"
  60        then
  61                echo "You still have unmerged paths in your index"
  62                echo "did you forget to use git add?"
  63                die "$RESOLVEMSG"
  64        fi
  65
  66        cmt=`cat "$dotest/current"`
  67        if ! git diff-index --quiet --ignore-submodules HEAD --
  68        then
  69                if ! git commit --no-verify -C "$cmt"
  70                then
  71                        echo "Commit failed, please do not call \"git commit\""
  72                        echo "directly, but instead do one of the following: "
  73                        die "$RESOLVEMSG"
  74                fi
  75                if test -z "$GIT_QUIET"
  76                then
  77                        printf "Committed: %0${prec}d " $msgnum
  78                fi
  79        else
  80                if test -z "$GIT_QUIET"
  81                then
  82                        printf "Already applied: %0${prec}d " $msgnum
  83                fi
  84        fi
  85        if test -z "$GIT_QUIET"
  86        then
  87                git rev-list --pretty=oneline -1 "$cmt" | sed -e 's/^[^ ]* //'
  88        fi
  89
  90        prev_head=`git rev-parse HEAD^0`
  91        # save the resulting commit so we can read-tree on it later
  92        echo "$prev_head" > "$dotest/prev_head"
  93
  94        # onto the next patch:
  95        msgnum=$(($msgnum + 1))
  96        echo "$msgnum" >"$dotest/msgnum"
  97}
  98
  99call_merge () {
 100        cmt="$(cat "$dotest/cmt.$1")"
 101        echo "$cmt" > "$dotest/current"
 102        hd=$(git rev-parse --verify HEAD)
 103        cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
 104        msgnum=$(cat "$dotest/msgnum")
 105        end=$(cat "$dotest/end")
 106        eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
 107        eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
 108        export GITHEAD_$cmt GITHEAD_$hd
 109        if test -n "$GIT_QUIET"
 110        then
 111                export GIT_MERGE_VERBOSITY=1
 112        fi
 113        git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
 114        rv=$?
 115        case "$rv" in
 116        0)
 117                unset GITHEAD_$cmt GITHEAD_$hd
 118                return
 119                ;;
 120        1)
 121                git rerere
 122                die "$RESOLVEMSG"
 123                ;;
 124        2)
 125                echo "Strategy: $rv $strategy failed, try another" 1>&2
 126                die "$RESOLVEMSG"
 127                ;;
 128        *)
 129                die "Unknown exit code ($rv) from command:" \
 130                        "git-merge-$strategy $cmt^ -- HEAD $cmt"
 131                ;;
 132        esac
 133}
 134
 135move_to_original_branch () {
 136        test -z "$head_name" &&
 137                head_name="$(cat "$dotest"/head-name)" &&
 138                onto="$(cat "$dotest"/onto)" &&
 139                orig_head="$(cat "$dotest"/orig-head)"
 140        case "$head_name" in
 141        refs/*)
 142                message="rebase finished: $head_name onto $onto"
 143                git update-ref -m "$message" \
 144                        $head_name $(git rev-parse HEAD) $orig_head &&
 145                git symbolic-ref HEAD $head_name ||
 146                die "Could not move back to $head_name"
 147                ;;
 148        esac
 149}
 150
 151finish_rb_merge () {
 152        move_to_original_branch
 153        rm -r "$dotest"
 154        say All done.
 155}
 156
 157is_interactive () {
 158        while test $# != 0
 159        do
 160                case "$1" in
 161                        -i|--interactive)
 162                                interactive_rebase=explicit
 163                                break
 164                        ;;
 165                        -p|--preserve-merges)
 166                                interactive_rebase=implied
 167                        ;;
 168                esac
 169                shift
 170        done
 171
 172        if [ "$interactive_rebase" = implied ]; then
 173                GIT_EDITOR=:
 174                export GIT_EDITOR
 175        fi
 176
 177        test -n "$interactive_rebase" || test -f "$dotest"/interactive
 178}
 179
 180run_pre_rebase_hook () {
 181        if test -z "$OK_TO_SKIP_PRE_REBASE" &&
 182           test -x "$GIT_DIR/hooks/pre-rebase"
 183        then
 184                "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
 185                die "The pre-rebase hook refused to rebase."
 186        fi
 187}
 188
 189test -f "$GIT_DIR"/rebase-apply/applying &&
 190        die 'It looks like git-am is in progress. Cannot rebase.'
 191
 192is_interactive "$@" && exec git-rebase--interactive "$@"
 193
 194if test $# -eq 0
 195then
 196        test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
 197        test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
 198                die 'A rebase is in progress, try --continue, --skip or --abort.'
 199        die "No arguments given and $GIT_DIR/rebase-apply already exists."
 200fi
 201
 202while test $# != 0
 203do
 204        case "$1" in
 205        --no-verify)
 206                OK_TO_SKIP_PRE_REBASE=yes
 207                ;;
 208        --continue)
 209                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 210                        die "No rebase in progress?"
 211
 212                git diff-files --quiet --ignore-submodules || {
 213                        echo "You must edit all merge conflicts and then"
 214                        echo "mark them as resolved using git add"
 215                        exit 1
 216                }
 217                if test -d "$dotest"
 218                then
 219                        prev_head=$(cat "$dotest/prev_head")
 220                        end=$(cat "$dotest/end")
 221                        msgnum=$(cat "$dotest/msgnum")
 222                        onto=$(cat "$dotest/onto")
 223                        GIT_QUIET=$(cat "$dotest/quiet")
 224                        continue_merge
 225                        while test "$msgnum" -le "$end"
 226                        do
 227                                call_merge "$msgnum"
 228                                continue_merge
 229                        done
 230                        finish_rb_merge
 231                        exit
 232                fi
 233                head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
 234                onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
 235                orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
 236                GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
 237                git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
 238                move_to_original_branch
 239                exit
 240                ;;
 241        --skip)
 242                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 243                        die "No rebase in progress?"
 244
 245                git reset --hard HEAD || exit $?
 246                if test -d "$dotest"
 247                then
 248                        git rerere clear
 249                        prev_head=$(cat "$dotest/prev_head")
 250                        end=$(cat "$dotest/end")
 251                        msgnum=$(cat "$dotest/msgnum")
 252                        msgnum=$(($msgnum + 1))
 253                        onto=$(cat "$dotest/onto")
 254                        GIT_QUIET=$(cat "$dotest/quiet")
 255                        while test "$msgnum" -le "$end"
 256                        do
 257                                call_merge "$msgnum"
 258                                continue_merge
 259                        done
 260                        finish_rb_merge
 261                        exit
 262                fi
 263                head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
 264                onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
 265                orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
 266                GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
 267                git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
 268                move_to_original_branch
 269                exit
 270                ;;
 271        --abort)
 272                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 273                        die "No rebase in progress?"
 274
 275                git rerere clear
 276                if test -d "$dotest"
 277                then
 278                        GIT_QUIET=$(cat "$dotest/quiet")
 279                        move_to_original_branch
 280                else
 281                        dotest="$GIT_DIR"/rebase-apply
 282                        GIT_QUIET=$(cat "$dotest/quiet")
 283                        move_to_original_branch
 284                fi
 285                git reset --hard $(cat "$dotest/orig-head")
 286                rm -r "$dotest"
 287                exit
 288                ;;
 289        --onto)
 290                test 2 -le "$#" || usage
 291                newbase="$2"
 292                shift
 293                ;;
 294        -M|-m|--m|--me|--mer|--merg|--merge)
 295                do_merge=t
 296                ;;
 297        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
 298                --strateg=*|--strategy=*|\
 299        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
 300                case "$#,$1" in
 301                *,*=*)
 302                        strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
 303                1,*)
 304                        usage ;;
 305                *)
 306                        strategy="$2"
 307                        shift ;;
 308                esac
 309                do_merge=t
 310                ;;
 311        -n|--no-stat)
 312                diffstat=
 313                ;;
 314        --stat)
 315                diffstat=t
 316                ;;
 317        -v|--verbose)
 318                verbose=t
 319                diffstat=t
 320                GIT_QUIET=
 321                ;;
 322        -q|--quiet)
 323                GIT_QUIET=t
 324                git_am_opt="$git_am_opt -q"
 325                verbose=
 326                diffstat=
 327                ;;
 328        --whitespace=*)
 329                git_am_opt="$git_am_opt $1"
 330                case "$1" in
 331                --whitespace=fix|--whitespace=strip)
 332                        force_rebase=t
 333                        ;;
 334                esac
 335                ;;
 336        --ignore-whitespace)
 337                git_am_opt="$git_am_opt $1"
 338                ;;
 339        --committer-date-is-author-date|--ignore-date)
 340                git_am_opt="$git_am_opt $1"
 341                force_rebase=t
 342                ;;
 343        -C*)
 344                git_am_opt="$git_am_opt $1"
 345                ;;
 346        --root)
 347                rebase_root=t
 348                ;;
 349        -f|--f|--fo|--for|--forc|force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase)
 350                force_rebase=t
 351                ;;
 352        -*)
 353                usage
 354                ;;
 355        *)
 356                break
 357                ;;
 358        esac
 359        shift
 360done
 361test $# -gt 2 && usage
 362
 363# Make sure we do not have $GIT_DIR/rebase-apply
 364if test -z "$do_merge"
 365then
 366        if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
 367        then
 368                rmdir "$GIT_DIR"/rebase-apply
 369        else
 370                echo >&2 '
 371It seems that I cannot create a rebase-apply directory, and
 372I wonder if you are in the middle of patch application or another
 373rebase.  If that is not the case, please
 374        rm -fr '"$GIT_DIR"'/rebase-apply
 375and run me again.  I am stopping in case you still have something
 376valuable there.'
 377                exit 1
 378        fi
 379else
 380        if test -d "$dotest"
 381        then
 382                die "previous rebase directory $dotest still exists." \
 383                        'Try git rebase (--continue | --abort | --skip)'
 384        fi
 385fi
 386
 387# The tree must be really really clean.
 388if ! git update-index --ignore-submodules --refresh > /dev/null; then
 389        echo >&2 "cannot rebase: you have unstaged changes"
 390        git diff-files --name-status -r --ignore-submodules -- >&2
 391        exit 1
 392fi
 393diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
 394case "$diff" in
 395?*)     echo >&2 "cannot rebase: your index contains uncommitted changes"
 396        echo >&2 "$diff"
 397        exit 1
 398        ;;
 399esac
 400
 401if test -z "$rebase_root"
 402then
 403        # The upstream head must be given.  Make sure it is valid.
 404        upstream_name="$1"
 405        shift
 406        upstream=`git rev-parse --verify "${upstream_name}^0"` ||
 407        die "invalid upstream $upstream_name"
 408        unset root_flag
 409        upstream_arg="$upstream_name"
 410else
 411        test -z "$newbase" && die "--root must be used with --onto"
 412        unset upstream_name
 413        unset upstream
 414        root_flag="--root"
 415        upstream_arg="$root_flag"
 416fi
 417
 418# Make sure the branch to rebase onto is valid.
 419onto_name=${newbase-"$upstream_name"}
 420onto=$(git rev-parse --verify "${onto_name}^0") || exit
 421
 422# If a hook exists, give it a chance to interrupt
 423run_pre_rebase_hook "$upstream_arg" "$@"
 424
 425# If the branch to rebase is given, that is the branch we will rebase
 426# $branch_name -- branch being rebased, or HEAD (already detached)
 427# $orig_head -- commit object name of tip of the branch before rebasing
 428# $head_name -- refs/heads/<that-branch> or "detached HEAD"
 429switch_to=
 430case "$#" in
 4311)
 432        # Is it "rebase other $branchname" or "rebase other $commit"?
 433        branch_name="$1"
 434        switch_to="$1"
 435
 436        if git show-ref --verify --quiet -- "refs/heads/$1" &&
 437           branch=$(git rev-parse -q --verify "refs/heads/$1")
 438        then
 439                head_name="refs/heads/$1"
 440        elif branch=$(git rev-parse -q --verify "$1")
 441        then
 442                head_name="detached HEAD"
 443        else
 444                usage
 445        fi
 446        ;;
 447*)
 448        # Do not need to switch branches, we are already on it.
 449        if branch_name=`git symbolic-ref -q HEAD`
 450        then
 451                head_name=$branch_name
 452                branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
 453        else
 454                head_name="detached HEAD"
 455                branch_name=HEAD ;# detached
 456        fi
 457        branch=$(git rev-parse --verify "${branch_name}^0") || exit
 458        ;;
 459esac
 460orig_head=$branch
 461
 462# Now we are rebasing commits $upstream..$branch (or with --root,
 463# everything leading up to $branch) on top of $onto
 464
 465# Check if we are already based on $onto with linear history,
 466# but this should be done only when upstream and onto are the same.
 467mb=$(git merge-base "$onto" "$branch")
 468if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
 469        # linear history?
 470        ! (git rev-list --parents "$onto".."$branch" | grep " .* ") > /dev/null
 471then
 472        if test -z "$force_rebase"
 473        then
 474                # Lazily switch to the target branch if needed...
 475                test -z "$switch_to" || git checkout "$switch_to"
 476                say "Current branch $branch_name is up to date."
 477                exit 0
 478        else
 479                say "Current branch $branch_name is up to date, rebase forced."
 480        fi
 481fi
 482
 483# Detach HEAD and reset the tree
 484say "First, rewinding head to replay your work on top of it..."
 485git checkout -q "$onto^0" || die "could not detach HEAD"
 486git update-ref ORIG_HEAD $branch
 487
 488if test -n "$diffstat"
 489then
 490        if test -n "$verbose"
 491        then
 492                echo "Changes from $mb to $onto:"
 493        fi
 494        # We want color (if set), but no pager
 495        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 496fi
 497
 498# If the $onto is a proper descendant of the tip of the branch, then
 499# we just fast forwarded.
 500if test "$mb" = "$branch"
 501then
 502        say "Fast-forwarded $branch_name to $onto_name."
 503        move_to_original_branch
 504        exit 0
 505fi
 506
 507if test -n "$rebase_root"
 508then
 509        revisions="$onto..$orig_head"
 510else
 511        revisions="$upstream..$orig_head"
 512fi
 513
 514if test -z "$do_merge"
 515then
 516        git format-patch -k --stdout --full-index --ignore-if-in-upstream \
 517                $root_flag "$revisions" |
 518        git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
 519        move_to_original_branch
 520        ret=$?
 521        test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
 522                echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
 523                echo $onto > "$GIT_DIR"/rebase-apply/onto &&
 524                echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head &&
 525                echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply/quiet
 526        exit $ret
 527fi
 528
 529# start doing a rebase with git-merge
 530# this is rename-aware if the recursive (default) strategy is used
 531
 532mkdir -p "$dotest"
 533echo "$onto" > "$dotest/onto"
 534echo "$onto_name" > "$dotest/onto_name"
 535prev_head=$orig_head
 536echo "$prev_head" > "$dotest/prev_head"
 537echo "$orig_head" > "$dotest/orig-head"
 538echo "$head_name" > "$dotest/head-name"
 539echo "$GIT_QUIET" > "$dotest/quiet"
 540
 541msgnum=0
 542for cmt in `git rev-list --reverse --no-merges "$revisions"`
 543do
 544        msgnum=$(($msgnum + 1))
 545        echo "$cmt" > "$dotest/cmt.$msgnum"
 546done
 547
 548echo 1 >"$dotest/msgnum"
 549echo $msgnum >"$dotest/end"
 550
 551end=$msgnum
 552msgnum=1
 553
 554while test "$msgnum" -le "$end"
 555do
 556        call_merge "$msgnum"
 557        continue_merge
 558done
 559
 560finish_rb_merge